"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ExitQuestionnaireInjectRD(ProtocolElement):
    """
    Record for exit questionnaire injection as part of the data intake for
    CVA
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "metadata",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import cva as cva_1_5_3
        from protocols.protocol_8_4 import reports as reports_6_8_0

        return {
            "exitQuestionnaireRd": cva_1_5_3.ExitQuestionnaireRD,
            "metadata": cva_1_5_3.InjectionMetadata,
            "rareDiseaseExitQuestionnaire": reports_6_8_0.RareDiseaseExitQuestionnaire,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import cva as cva_1_5_3
        from protocols.protocol_8_4 import reports as reports_6_8_0

        return {
            "org.gel.models.cva.avro.ExitQuestionnaireRD": cva_1_5_3.ExitQuestionnaireRD,
            "org.gel.models.cva.avro.InjectionMetadata": cva_1_5_3.InjectionMetadata,
            "org.gel.models.report.avro.RareDiseaseExitQuestionnaire": reports_6_8_0.RareDiseaseExitQuestionnaire,
            "org.gel.models.cva.avro.ExitQuestionnaireInjectRD": cva_1_5_3.ExitQuestionnaireInjectRD,
        }

    __slots__ = [
        "metadata",
        "exitQuestionnaireRd",
        "rareDiseaseExitQuestionnaire",
    ]

    def __init__(
        self,
        metadata,
        exitQuestionnaireRd=None,
        rareDiseaseExitQuestionnaire=None,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_3.ExitQuestionnaireInjectRD model.

        :param metadata:
            Metadata on the exit questionnaire
        :type metadata: InjectionMetadata
        :param exitQuestionnaireRd:
            Exit questionnaire for rare disease
        :type exitQuestionnaireRd: None | ExitQuestionnaireRD
        :param rareDiseaseExitQuestionnaire:
            Rare disease exit questionnaire
        :type rareDiseaseExitQuestionnaire: None | RareDiseaseExitQuestionnaire
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.3"
